#include "TrimmedSequence.hh"

TrimmedSequence::TrimmedSequence(const string & name)
{
  m_seqname = name;
}

TrimmedSequence::~TrimmedSequence()
{

}

void TrimmedSequence::addData(char * buffer, bool isQual)
{
  // Trim off trailing whitespace
  char * endbuf = buffer + (strlen(buffer) - 1);
  while (*endbuf == ' ' && endbuf >= buffer)
  {
    *endbuf = '\0';
    endbuf--;
  }

  if (strlen(buffer))
  {
    if (isQual)
    {
      m_qual.append(buffer);
      m_qual.append(" ");
    }
    else
    {
      m_seq.append(buffer);
    }
  }
}

const string & TrimmedSequence::getNuc() const
{
  return m_seq;
}

const string & TrimmedSequence::getQual()
{
  string::size_type end = m_qual.length()-1;
  
  // Trim trailing spaces
  while (m_qual[end] == ' ') { end--; }

  string swap = m_qual.substr(0, end+1);
  m_qual = swap;

  return m_qual;
}
